# Patch file for Keen - use with CK4PATCH.EXE

%ext ck4

# GENERAL STUFF

#map files
%maphead maphead.ck4
%patchfile $249C2 modtiles.tli

#Load graphics
%egahead EGAHEAD.CK4
%egadict EGADICT.CK4		#Use KG graphics

%patchfile $1EE40 "STORY.CK4" 

#Keenwave patch file; Patch sounds:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary

%patchfile $1fe47 CK4LOAD.BIN


###### LASS ADDITIONS ####
#Terminator text palette:
%patch $2F078 $00 $01 $01 $11 $01 $01 $01 $01     #Dark colors
              $04 $04 $04 $04 $14 $14 $14 $14 $00 #Light colors (and border color)

#Change the status window
#Rescued
%patch $7E2F $011FW #Text read from
%patch $2EF8F "GENERAORS" $00

#Drops
%patch $8015 $062CW #Text read from
%patch $2F49C "SPARKS" $00

#Wetsuit
%patch $808E $0129W #Read text from here
%patch $809C $0135W #Else read text from here
%patch $2EF99 "BRIDGES ON " $00 
%patch $2EFA5 "BRIDGES OFF" $00
%patch $807E $004CW #Horizontal (Text)
%patch $8084 $0050W #Maximum text width

%patch $8061 $0017W #Width
%patch $8069 $0082W #Horizontal


#################
#High scores	#
#################

#This patch removes the oracle squares from the High Scores level, ever.
#Oracle tiles not displayed ever in High Scores
%patch $6BAC $7A1EW


#################
#Wetsuit	#
#################

#Disable giving wetsuit on BAT and F10-I cheat
%patch $788F $EB $02 #BAT cheat
%patch $755C $EB $04 #F10-I cheat

#Keen can never swim on map
%patch $E206 $EB $05

#Change music when Wetsuit got
%patch $12A51 $06BD20C7RL
%patch $12A4D $0001W      #Play this level's song

###### END LASS ADDITIONS ####



############ TEXT BOXES AND STUFF #########################

#Names
%patch $33234 "Ceilick          " $00
%patch $33274 "Lemm             " $00
%patch $332B4 "Gamebird         " $00
%patch $332F4 "Levellass        " $00
%patch $33334 "Mr. M            " $00
%patch $33374 "Tom Hall         " $00
%patch $333B4 "Molly McMire     " $00
%patch $333F4 "Atroxus          " $00







                                            
###############################################
################LEVELS########################
###############################################

#Allow 24 levels in Keen 4 v1.4: 
#First increase the number of levels we can access from the map to maximum (+6) 
%patch $DF5D $C018W #Number of levels enterable ($18 = 24) 
%patch $60FD 24		#Highest level that will be checked for level-dependent 
					#blocking tile removal and flag flippage

#Number of level song entries check
%patch $8CA4 25 #need to make it 1 higher than # of levels, for whatever reason

#Warp cheat
%patch $77E4 24

#Add temporary text values to lists: 
#Level name pointers: 
%patch $30764 $1F040000RL #Map 
              $1F050000RL #Level 1 
              $1F060000RL #Level 2 
              $1F070000RL #Level 3 
              $1F090000RL #Level 4... 
              $1F0B0000RL 
              $1F0C0000RL 
              $1F0D0000RL 
              $1F0E0000RL 
              $1F0F0000RL 
              $1F100000RL 
              $1F110000RL 
              $1F130000RL 
              $1F150000RL 
              $1F180000RL 
              $1F1A0000RL 
              $1F1B0000RL 
              $1F1C0000RL 
              $1F1D0000RL #Bwb Rocket 
              $1F1C0000RL #Hall of fame 
              $2EE71C50RL #20
              $2EE71C50RL #21
              $1F1C0000RL 
              $1F1C0000RL 
              $1F1C0000RL 

#Level entrance text pointers 
%patch $307C8 $1F1F0000RL #Map 
              $1F210000RL #Level 1 
              $1F240000RL #Level 2 
              $1F260000RL #Level 3... 
              $1F290000RL 
              $1F2D0000RL 
              $1F300000RL 
              $1F330000RL 
              $1F350000RL 
              $1F380000RL 
              $1F3A0000RL 
              $1F3D0000RL 
              $1F400000RL 
              $1F430000RL 
              $1F470000RL 
              $1F4B0000RL 
              $1F4E0000RL 
              $1F510000RL 
              $1F540000RL #Bwb Rocket 
              $1F510000RL #Hall of fame 
              $2EE71C60RL #20
              $2EE71C80RL 
              $1F510000RL 
              $1F510000RL 
              $1F510000RL

%patch $1F040 "Krisle    " $00

%level.name 0 Krisle
%level.entry 0 Keen searches\n planet Krisle

%level.name 1 Dark Swamp
%level.entry 1 Keen explores the \n Dark Swamp

%level.name 2 Murky Marsh
%level.entry 2 Keen marches\n into Murky Marsh

%level.name 3 Larvae Lagoon
%level.entry 3 Keen lurks in\n the Larvae Lagoon


%patch $30AC0 "?" $00
%patch $30AD0 "Keen enters the" $0A
			  "?" $00
%patch $30AF0 "Keen continues through" $0A
			  "the ?" $00

 

%patch $2F191 "Exit to Krisle" $00

#Text plane starts at $2EE70
#Spare text starts at $3D740 = +E8D0 (5935 sp)

###############################################
##################Music########################
###############################################

##Change number of songs:
%patch $8CEF $8A $00
%patch $8C75 $C871W
%patch $8C83 $C871W
%patch $8D83 $C871W
%patch $8C91 24

#Keenwave patch file; Patch sounds:
%patchfile $20DF0 AUDIOHED.CK4	#Audio header
%patchfile $354F6 AUDIODCT.CK4	#Audio dictionary


#Where music list is read from:
%patch $8CCD $96 $03 #$2F206

#Song values:
#0: Shadowlands       1: Eat your Veggies
#2: Too hot           3: Slug village
#4: Kick in the pants 5: Ancients

#This is the music played in each level:
#             VALUE   LEVEL                 MUSIC PLAYED         LEVEL No
%patch $2F206 $01 $00 #Map                  (Shadowlands)          0
              $02 $00 #Dark Swamp           (Kick in the Pants)    1
              $03 $00 #Murky Marsh          (Slug Village)         2
              $04 $00 #Larvae Lagoon        (Slug Village)         3
              $05 $00 #? (Too Hot)              4
              $06 $00 #?       (Too Hot)              5
              $07 $00 #?        (Kick in the Pants)    6
              $08 $00 #?        (Slug Village)         7
              $09 $00 #?      (Eat your Veggies)     8
              $0A $00 #?          (Eat your Veggies)     9
              $0C $00 #?         (Eat your Veggies)    10
              $13 $00 #?          (Too Hot)             11
              $0D $00 #?        (Too Hot)             12
              $0E $00 #?          (Too Hot)             13
              $0F $00 #?       (Too Hot)             14
              $10 $00 #?      (Too Hot)             15
              $11 $00 #?         (Too Hot)             16
              $14 $00 #?      (Eat your Veggies)    17
              $12 $00 #?   (Slug Village)        18
              $FF $FF #High scores          (No music, "Fanfare") 19
	      	  $0B $00 #?     (Slug Village)        20
	      	  $0B $00 #?    (Slug Village)        21
	      	  $17 $00 #?       (Slug Village)        22
	          $00 $00 #ScrollingPlaceHolder (Scrolling)           23  
	      	  $15 $00 #EndingPlaceholder    (Ending)              24  

#Other music played: (Values here is number of LEVEL who's music is used)
%patch $5836 $17 $00 #Story demo (Too hot)
%patch $9CD7 $18 $00 #Ending Sequence (Slug Village)
%patch $F107 $FF $FF #Talking to Lindsey (Ancient)


#Council Member
%patch $F4CA $FF $FF #Talking to Ancient (Ancient)
#Change "start music" into "stop music"
%patch $F4CD $9A $06BD2092RL



###############################################
################ ACTORS #######################
###############################################

#DRAWFUNC2: This affects inchworms, mimrocks, and a bunch of other things that turn around at edges and walls
#check topflags: if offset = 0, then assumed that we did not walk off a cliff
# stops them from flipping out 

%patch $B5C5
$3D 0W			#cmp ax, 0
$74 $1D			#jz drawsprite
$29 $44 $0A		#sub [si+objtype.xpos], ax
$F7 $5C $0E		#neg word ptr [si+objtype.xmotion]


#################
# KEEN          #
#################

#do the land death on map 17
%patch $CC2F $EB #turn jnz into jmp short

#Keen can't look up on platforms
#SIDE EFECT: Keen takes a little time to stop looking up if up key held long
%patch $2FAA0 $0B80139FRL
%patch $2FA9A $0018W
%patch $2FAAC $09AAW
%patch $2FA94 $0004W
                                 
#################
#Oracle		#
#################

#If you want the member to be deadly, the easiest way is to put an invisible
#deaadly tile behind him, when Keen touches that, he dies.

# Council Member Cache start
#%patch $306F2 $015EW 

# Council member zplane
%patch $FD07 3W  


#ACTIONS
#Member doesn't  move when walking; collision function set to new
%patch $30E28
356W 356W 2W 0W 0W 2W 0W 0W  $09DC172ERL $0FA80720RL $09DC176ERL 0x1FB8W

# Smirky smoke actions
350W 350W 0W 0W 0W 8W 0W 0W  $0L $0L $09DC176ERL 0x1FF4W
351W 351W 0W 0W 0W 8W 0W 0W $0L $0L $09DC176ERL 0x2774W

# Overwrite Wormmouth actions (use wormmouth peep 4 to wormmouth peep 6)
%patch $315E4
352W 352W 0W 0W 0W 8W 0W 0W $0L $0L $09DC176ERL 0x2792W
353W 353W 0W 0W 0W 8W 0W 0W $0L $0L $09DC176ERL 0x27B0W
354W 354W 0W 0W 0W 8W 0W 0W $0L $0L $09DC176ERL 0W


#Explosion Animation Actionus
#These overwrite the ID_CA error messages and the AUDIO.CK4 error message (DSEG:3B12)
%patch $32982

357W 357W 0W 0W 0W 15W 0W 0W  $0L $0L $09DC176ERL 0x3B30W	# a_coreexplode1
358W 358W 0W 0W 0W 15W 0W 0W  $0L $0L $09DC176ERL 0x3B4EW	#
359W 359W 0W 0W 0W 15W 0W 0W  $0L $0L $09DC176ERL 0x3B6CW	#
360W 360W 0W 0W 0W 15W 0W 0W  $0L $0L $09DC176ERL 0x3B8AW	#
361W 361W 0W 0W 0W 15W 0W 0W  $10800770RL $0L $09DC176ERL 0x3B8AW	#Loops (but game ends when think is called, so it doesn't really matter anyway)

#Member doesn't spawn message if keen touches him ( doesn't apply to level 14, i.e., janitor)
%patch $CDAB $90 $90 $90 $90 $90 $90 $90 $90 
			 $90 $90 $90 $90 $90 $90 $90 $90 
			 $90 $90 

#Shooting the member activates him: (Touching him does nothing.)
#NOVEL collision function that changes to explosion action on shot contact
#override (inchworm_move)

#(seg010:720)
%patch $101A0
$55 $8B $EC $56 $57  $8B $7E $06 $8B $76 $08 #push bp mov bp, sp pushsi push di mov di, [bp+arg_0] mov si, [bp+arg_2]
$83 $3C $03				#cmp word ptr [si], 3
$75 $18					#jnz return
$C7 $45 $1C $3B12W  			#mov [di+objtype.action], a_coreexplode_0

					#;make stunner zap
$56					#push si
$9A $0D8F0D43RL				#call StunnerZaps
$44 $44 				#inc sp inc sp

#instead of making the stunner "zap," it will be transformed into smoke
#$C7 $44 $1C $1FD6W  			#mov [si+objtype.action], a_stunnersmoke_0
#$90 $90 $90

$B8 0x1FW 		#mov ax, CustomSound
$50					#push ax
$9A $187409F1RL				#Call SD_PlaySound
$44 $44 				#inc sp inc sp

$5F $5E $5D $CB 			#pop di, si, bp, retf



#New think function that sets word_468E0 to 3 (overwrites the end of Egg collide)

#seg(011:0770)
%patch $10F70
$55					#push 	bp
$8B $EC 				#mov    bp, sp
$56					#push   si
$8B $76 $06				#mov    si, [bp+arg_0]
$C7 $06 $70 $7A $03 $00			#mov [word_468E0], 3
					#
					#return:
$5E					#pop	si
$5D					#pop	bp
$CB					#retf



#################
#Clouds		#
#################

#actions
%patch $3172E
0x1F2W 0x1F2W 4W 0W 0W 18W 0W 0W $1080020CRL $1080037DRL $108002E1RL 0x28DCW	# two frame movement
0x1F3W 0x1F3W 4W 0W 0W 18W 0W 0W $1080020CRL $1080037DRL $108002E1RL 0x28BEW


#5 launching actions; this frees up four extra animations (extra space for schoolfish)
%patch $317A6
0x1F2W 0x1F2W 0W 0W 0W 10W 0W 0W 0L 0L $09DC176ERL 0x2954W
0x1F3W 0x1F3W 0W 0W 0W 10W 0W 0W 0L 0L $09DC176ERL 0x2972W
0x1F2W 0x1F2W 0W 0W 0W 10W 0W 0W 0L 0L $09DC176ERL 0x2990W
0x1F3W 0x1F3W 0W 0W 0W 10W 0W 0W $1080032ARL 0L $09DC176ERL 0x29AEW	# launch after this action
0x1F4W 0x1F4W 0W 0W 0W 48W 0W 0W 0L 0L $09DC176ERL 0x2918W

#Cloud is spawned awake and moving
%patch $109FE $28DCW

#Cloud function kills keen on contact
%patch $10B90 $9A $0B8013E9RL

#cloud_strike:
#Cloud strike spawns a schoolfish
%patch $10B43 $16W	 #schoolfish type
#%patch $10B4D $0002W #clipping type

#mov default speed into int34
#clipping is now default value of 1
%patch $10B4A $C7 $47 $44 10W		#mov word ptr [bx+objtype.int34], 10W


%patch $10B62 $3764W #starting action
##



#increase lighting bolt range
%patch $10A5C
$8B $1E $A7D6W  # mov bx, [player]
$8B $47 $2A		# mov ax, [bx+object.boxXmid]
$2B	$44	$2A		# sub ax, [si+object.boxXmid]
$99				# cwd
$31 $D0			# xor ax, dx
$29 $D0			# sub ax, dx
$3D $0900W		# cmp ax, 0x900
$73 $05			# jge return
$C7 $44 $1C $28FAW #mov [si+object.action], 28FA



#################
#Schoolfish		#
#################


#actions
%patch $325D4
0x1A5W 0x1A5W 3W 0W 0W 10W 0W 0W $11A20AF6RL $11A2017DRL $11A20A3CRL 0x3782W
0x1A6W 0x1A6W 3W 0W 0W 10W 0W 0W $11A20AF6RL $11A2017DRL $11A20A3CRL 0x29CCW

# two more actions, in the unused cloud spots
%patch $3183C
0x1A7W 0x1A7W 3W 0W 0W 10W 0W 0W $11A20AF6RL $11A2017DRL $11A20A3CRL 0x29EAW
0x1A8W 0x1A8W 3W 0W 0W 10W 0W 0W $11A20AF6RL $11A2017DRL $11A20A3CRL 0x3764W

#Movement function
# Use one of the temp variables (int34) to dictate speed
%patch $1253B $FF $74 $44 $90 #push [si+objtype.int34]; nop

# Draw Function
# increase counter and set int31 flag if high enough
%patch $1246F $C7 $44 $3E $200W $90 $90 $90 $90 #set flag if touched top/bottom
%patch $12494 $200W #set flag if touched left/right

# set schoolfish to lighting actions (explosions) if flag exceeded
%patch $12496
$FF $44 $3E			#inc [si+objtype.int31]
$81 $7C $3E $0200W	#cmp [si+objtype.int31], XXXXW
$7C $07				#jl drawsprite
$C7 $44 $1C $2A44W  #mov [si+objtype.action], A_LIGHTNING
$90 $90

#NOVEL schoolfish collision
# placed in the middle of the smirky search function
# THIS CAN"T RUN PAST $11C04 or else it will overwrite novel smirky function 
# Also note that there is other smirky patching above this; don't expand that patching too much
# patched at $11A2017DRL

%patch $11B9D
$55 $8B $EC $56 $57		#push bp #mov bp,sp #push si #push di
$8B $76 $06				#mov si, [bp+arg0]
$8B $7E $08				#mov di, [bp+arg2]
$83 $3D $02				#cmp word ptr [di], 2  ; contacted is keen
$75 $0A					#jnz Ret
$C7 $44 $3E $0200W		#mov [si+objtype.int31], XXXXW ; trigger explosion threshold
$9A $0B8013E9RL			#call KeenDie
						#Ret:
$5F $5E $5D $CB			#pop di; pop si; pop bp; retf




#################
#Poison slugs   #
#################

#ACTIONS

#2 x slug walking
# use same frames for L/R; doulbe the slug sliming frequency
%patch $30E82 $13BW $13BW $0W $0W 1W 8W $40W 0W $0FA80369RL $0FA803EARL $09DC1847RL $2030W 
%patch $30EA0 $13CW $13CW $0W $0W 1W 8W $40W 0W $0FA80369RL $0FA803EARL $09DC1847RL $2012W 

# Since the second death animation action is now free, we can use it for spawning the slug slime at
# the beginning of the pause

%patch $30EBE $142W $13DW 0W 0W 1W 6W 0W 0W $0FA803A6RL $0FA803EARL $09DC1847RL $208AW
%patch $30EFA $142W $13DW 0W 0W 1W $60W 0W 0W $0L $0FA803EARL $09DC1847RL $2012W



#Only use the first death animation
%patch $FEA3 $206CW


#Change slug sliming frequency
%patch $FDF6 $10                #Fine tune frequency: higher = more often

#Slug slime moves up and doesn't evaporate, it disapears when it hits ceilings
#Dart speed is $40 (64) slime speed now 88% of this ($38 or 56)
#Speed ALSO depends on aniamtion time! Using dart time here of 6
%patch $30F30 $11A20CA1RL       #Bust on ceiling 1
%patch $30F4E $11A20CA1RL       #Bust on ceiling 2
%patch $30F24 $00 $00 $38 $00   #Speed 1
%patch $30F42 $00 $00 $38 $00   #Speed 2
%patch $30F22 $0004W            #Animate 1
%patch $30F40 $0004W            #Animate 2
%patch $30F52 $20A8W            #Don't evaporate, animate
%patch $FE48  $10 $FF $FF       #Move up
%patch $FE55  $100W             #Spawn Higher (100h map units above slug)


#################
#Skypest        #
#################

#Frees up all skypest preening actions and sprites, Skpyest could have
#more flying animations or death animations (E.g. turn to ashes and crumble away.)

#Skypest pushes Keen, doesn't kill:
%patch $106E7 $90 $90 $90 $90 $90
%patch $105FB $0F

#Skypest shootable:
%patch $106F0 $12 $B8 $24C2W $50 $57 $56 $9A $09DC1695RL
              $83 $C4 $06 $83 $6C $18 $10 $5F $5E $5D $CB

#Skypest doesn't land:
%patch $107BA $2486W

#Shootable Skypest goes poof (Uses Skypest preening actions 4-6)
%patch $31332 $015AW $015AW $0000W $0000W $0000W $0008W $0000W $0000W 
              $00000000L    $00000000L    $09DC176ERL   $251CW
%patch $3138C $015BW $015BW $0000W $0000W $0000W $0008W $0000W $0000W 
              $00000000L    $00000000L    $09DC176ERL   $253AW
%patch $313AA $015CW $015CW $0000W $0000W $0000W $0008W $0000W $0000W 
              $00000000L    $00000000L    $09DC176ERL   $2558W
%patch $313C8 $015DW $015DW $0000W $0000W $0000W $0008W $0000W $0000W 
              $00000000L    $00000000L    $09DC176ERL   $0000W




%patch $31D0A
0x14FW 0x14DW 3W 0W 1W 8W 0x58W 0x20W $11A20140RL $10800793RL $09DC1795RL 0x2EB8W
0x150W 0x14EW 3W 0W 1W 8W 0x58W 0x20W $11A20140RL $10800793RL $09DC1795RL 0x2E9AW

#2 inchworms make Smirky smoke:
%patch $10FC1 $01 $00           #Number needed for smoke = 2
%patch $110C3 $EB               #Don't remove all inchworms on collision
%patch $10FDE $2E22W            #Spawn foot puff instead of foot
%patch $10FD7 $00 $00           #Spawn puff where inchworm was
%patch $10FDB $10 $00           #Stop puff taking Keen to map
%patch $31CA6 $09DC1752RL       #Make puff kill Keen
%patch $31CC4 $09DC1752RL
%patch $31CE2 $09DC1752RL
%patch $31D00 $09DC1752RL
%patch $11016 $9090W $9090W $90 #Remove other foot puffs
%patch $1104A $9090W $9090W $90
%patch $1107E $9090W $9090W $90
%patch $110AF $9090W $9090W $90

 
# inchworm mov function rewritten
# NOTE: This is written int he Smirky Search, ABOVE the schoolfish and below the new Smirky Search
# patched at $11A20140RL
# TODO: make sure this doesn't interfere with smirky
%patch $11B60
0x55 0x8B 0xEC 0x56 0x8B 0x76 0x06 0x8B  0x44 0x0A 0x8B 0x1E 0xD6 0xA7 0x3B 0x47  
0x0A 0x76 0x08 0xC7 0x44 0x0E 0xFF 0xFF  0xE9 0x05 0x00 0xC7 0x44 0x0E 0x01 0x00  
0x56 0x9A $09DC1296RL $83 $C4 $02 $5E $5D $CB #move in direction of keen; call AddGravity
 





#SIDE EFFECT: Game will crash if sprites and Berkeloids are not
#BOTH in the the level to cache each other's sprites!

#Swap the shooting sprite and Berkeloid and thus what they shoot:
#%patch $31A74 $37DCW            #Berkeloid
#%patch $31A92 $37A0W            #Berkeloid
#%patch $12656 $2C06W            #Sprite
#%patch $32686 $2C24W            #Sprite

#Change sprites so nothing is amiss:
#%patch $3264C $01FFW $0201W #Berk shoot looks like sprite
#%patch $3266A $0200W $0202W #Sprite shoot looks like Berk

#Use sprite shooting think in berkeloid action (a_BerkeloidThrow5)
%patch $31A86 $11A20C3BRL

#.. and berk shooting thing in sprite action
%patch $3265C $108004A4RL

#Stop sprite float:
%patch $125D9 $00 $00

#Keen can sneak up behind Berks without them noticing. 
%patch $10C1C $00

#Sprites only face left
%patch $1262B $EB $08

# Sprite Shooting Sound (used for berkeloids)
# As it is, 3 sounds would be played
# We just want sound 0x21 to be played, so nop out the other two soundplay calls
#Sound #1
%patch $12690 $21W			#sound number (default 0x4)
#%patch $12693 $90 $90 $90 $90 $90	#prevent sound from playing

#Sound #2
%patch $126B3 $26W			#sound number (default 0x26)
%patch $126B6 $90 $90 $90 $90 $90	#prevent sound from playing

#Berkeloid Throwing sound (also used for berkeloids)... doesn't seem to be played if keen is behind berks
%patch $10C93 $21W			#sound number (default 0x21)
%patch $10C96 $90 $90 $90 $90 $90 	#prevent sound from playing

#XVel speed in berkeloid moving actions (actiontype is already 1, stick to ground already true)
%patch $31992 12W
%patch $319B0 12W
%patch $319CE 12W
%patch $319EC 12W


#Berkeloid Throwing:  
#change all action types from 0 to 1 and 
%patch 0x319E4 1W 
%patch 0x31A02 1W 
%patch 0x31A20 1W
%patch 0x31A3E 1W
%patch 0x31A5C 1W
%patch 0x31A7A 1W #sprites use this action
%patch 0x31A98 1W
%patch 0x31AB6 1W
%patch 0x31AD4 1W
%patch 0x31AF2 1W
%patch 0x31B10 1W
%patch 0x31B2E 1W

# increase XVel from 0 to something
%patch 0x319EC 12W
%patch 0x31A0A 12W
%patch 0x31A28 12W
%patch 0x31A46 12W
%patch 0x31A64 12W
%patch 0x31A82 12W #sprites use this action
%patch 0x31AA0 12W
%patch 0x31ABE 12W
%patch 0x31ADC 12W
%patch 0x31AFA 12W
%patch 0x31B18 12W
%patch 0x31B36 12W

# Change the draw function so that Berkeloids don't wander off the sides of platforms
# when they are throwing
%patch 0x319F8 $10800610RL
%patch 0x31A16 $10800610RL
%patch 0x31A34 $10800610RL
%patch 0x31A52 $10800610RL
%patch 0x31A70 $10800610RL #sprites use this action
%patch 0x31A8E $10800610RL
%patch 0x31AAC $10800610RL
%patch 0x31ACA $10800610RL
%patch 0x31AE8 $10800610RL
%patch 0x31B06 $10800610RL
%patch 0x31B24 $10800610RL
%patch 0x31B42 $10800610RL

# Change all the throwing actions to have stick to ground enabled
%patch 0x319E8 1W 
%patch 0x31A06 1W 
%patch 0x31A24 1W
%patch 0x31A42 1W
%patch 0x31A60 1W
%patch 0x31A7E 1W #sprites use this action
%patch 0x31A9C 1W
%patch 0x31ABA 1W
%patch 0x31AD8 1W
%patch 0x31AF6 1W
%patch 0x31B14 1W
%patch 0x31B32 1W

#################
#Licks          #
#################

#Licks are always deadly:
%patch $31E4A $10800C23RL
%patch $31E68 $10800C23RL
%patch $31E86 $10800C23RL
%patch $31EA4 $10800C23RL

#No short jumps, only long ones:
%patch $113CB $90 $90

#Fine tune jump:
%patch $113DA $C0 $FF #Height
%patch $113D1 $03     #Length

#Flame-slide attack range:
%patch $11395 $00 $04 #Left  (+3)
%patch $113A6 $00 $FB #Right (-3)

#Stop position bug:
%patch $11390 $00 #Left
%patch $113A1 $00 #Right

#Licks slide when they flame: ($20 is speed.)
%patch $31EBA $30 $00 $00 $00 #Speed 1
%patch $31ED8 $30 $00 $00 $00 #Speed 2
%patch $31EF6 $30 $00 $00 $00 #Speed 3
%patch $31F14 $30 $00 $00 $00 #Speed 4
%patch $31F32 $30 $00 $00 $00 #Speed 5
%patch $31F50 $30 $00 $00 $00 #Speed 6
%patch $31F6E $30 $00 $00 $00 #Speed 7
%patch $31F8C $30 $00 $00 $00 #Speed 8

#Lick appears behind Keen
%patch $112E6 $0001W #Lick


%patch $3237A $58                     #Mimrock doesn't slam back down, once activated.

###
#Mimrock
###


#mimrock z-layer = 2 (behind foreforegroundtiles)
%patch $11E85 $02	

#Mimrocks always pursue Keen
%patch $11EEB $90 $90 $90 $90 $90 $90 #Remove 'Is Keen looking at me?' checks
%patch $11F05 $90 $90 $90 $90 $90 $90
%patch $11F3B $90 $90 $90 $90 $90 $90 $90 $90  #Don't make the Mimrock slam down if he spies Keen

#Distance to Trigger Walking
%patch $11EDF $0010W

#Distance to Trigger Sliding
%patch $11F53 $0500W

#replace collisions in mimrock waiting and walking to that of berkeloid
%patch $322BE	$10800530RL
%patch $322DC	$10800530RL
%patch $322FA	$10800530RL
%patch $32318	$10800530RL
%patch $32336	$10800530RL
%patch $32354	$10800530RL
%patch $32372	$10800530RL


#replace mimrock jumping actions with sliding actions
%patch $3237C	$190W	$18DW	4W	0W	0W	24W	0W	0W	$09DC16E5RL	$11A2059FRL	$09DC176ERL	$352AW  #slide frame 0
%patch $3239A	$191W	$18EW	4W	0W	0W	10W	0W	0W	$09DC16E5RL	$11A2059FRL	$09DC176ERL	$3548W	#slide frame 1
%patch $323B8	$192W	$18FW	4W	0W	0W	10W	0W	0W	$09DC16E5RL	$11A2059FRL	$09DC176ERL $3566W	#slide frame 2
%patch $323D6	$192W	$18FW	2W	0W	0W	0W	0W	0W	$09DC16E5RL	$11A2059FRL $11A2062ERL 0W		#if fell of a cliff, wait	

#alter mimrock jump trajectory
%patch $11F5B 30W		# breadth (mimrock jump speed)
%patch $11F65 08W		# height



#smirky actions

# 2 frame walking loop
%patch 0x32052 $152W $153W 0W 0W 1W 6W 40W 0W 0x11A20079RL 0x11A20279RL 0x10800610RL 0x3200W   
%patch 0x32070 $152W $153W 0W 0W 1W 6W 40W 0W 0x11A20079RL 0x11A20279RL 0x10800610RL 0x31e2W

# 8 teleport actions here: same as default, but collisions removed
%patch 0x3208E $15EW $15EW 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $323CW
%patch 0x320AC $15FW $15FW 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $325AW
%patch 0x320CA $160W $160W 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $3278W
%patch 0x320E8 $161W $161W 0W 0W 0W 20W 0W 0W $11A2022ARL   0L $09DC176ERL $3296W
%patch 0x32106 $161W $161W 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $32B4W
%patch 0x32124 $160W $160W 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $32D2W
%patch 0x32142 $15FW $15FW 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $32F0W
%patch 0x32160 $15EW $15EW 0W 0W 0W 20W 0W 0W 0L			0L $09DC176ERL $3386W  #last action goes back to walkign

# stun sequence (replaces jump sequence); last action sets new locat and switches to tele in action
%patch 0x3217E 0x15EW 0x15EW 0W 0W 0W 20W 0W 0W 0L          0L 0x09DC176ERL 0x332CW
%patch 0x3219C 0x15FW 0x15FW 0W 0W 0W 20W 0W 0W 0L          0L 0x09DC176ERL 0x334AW
%patch 0x321BA 0x160W 0x160W 0W 0W 0W 20W 0W 0W 0L          0L 0x09DC176ERL 0x3368W
%patch 0x321D8 0x161W 0x161W 0W 0W 0W 20W 0W 0W $11A201E4RL 0L 0x09DC176ERL 0x3296W # last action goes to tele4

# post teleport action (replaces shot action); fall to the ground for a second so we don't respawn in air
%patch $321F6  0x152W 0x153W 0W 0W 1W 40W 0W 0W $09DC16C9RL	0L $09DC176ERL $31E2W

# spawn action: call new function once at spawn to set int33/34 to post-stun teleport map location
%patch $32214 $152W $153W 0W 0W 1W 8W 0W 0W 0x11A20100RL	0L	0L	0x31E2W


#
# smirky spawn behaviour
#

#set int32 to 8
%patch $11A6B	$90 $90
%patch $11A71	$C7 $47 $40 $8W $90 $90
%patch $11A8B	$33A4W

%patch $11A47 2W #active type: 0 = dead, 1 = active onscreen only, 2 = always, 3 = disappear once offscreen

#NOVEL smirky spawning action
#not enough room in the original spawn behaviour, so just create a "run-once" behaviour
#NOTE: This overwrites the original Searching patch
%patch $11B20				#11A2:100
$55							#push bp
$8B $EC						#mov bp, sp
$56							#push si
$57							#push di
$8B $76 $06					#mov si, [bp+arg0]

$8A	$44 $0B					#mov al, [si+object.posx+1] ; move pre teleport mappos into int33 (return loc)
$C1 $E0 $08					#shl ax, 8
$8A	$44 $0D					#mov al, [si+object.posy+1]
$89 $44 $42					#mov [si+object.int33], ax

$5F							#pop di
$5E							#pop si
$8B $E5						#mov bp, sp
$5D							#pop bp
$CB							#retf
 

#
#smirky searching behaviour
#

#going to check for the uppermost arachnut, it must be on-screen
#if it is found, store its object pointer in cx

%patch $11AA4	$90 $90 $90 $90 $90  #don't reset smirky behaviour
%patch $11AA4	$BA $00FFW	#mov dx, 255
		$31 $C9		#xor cx,cx
%patch $11AB0	
$EB $17						# jmp nextsprite
$83 $3D $0A					# check if an arachnut is seen  
$75 $12						# jnz nextsprite

# doesn't matter if it's active
#$90 $90 $90 $90  #$83 $7D $02 $01				# check if sprite active
#$90 $90 #$75 $0B						#jnz nextsprite

# Check if the arachnut is stunned
# That is, if the arachnut's action pointer is greater than the walking actions
# Hmm... this doesn't seem to work though... better just make the timer larger
#$81 $7D $1C $2396W				#cmp [di+OBJECT.action], a_arachnutwalk_1 ; $2396
#$7F 11 #jg nextsprite
$90 $90 $90 $90 $90
$90 $90

# now check if it is the topmost arachnut
$8B $45 $2E					#mov ax, [di+object.boxTY1]
$3B $C2						#cmp ax, dx
$7F $04						#jg nextsprite

$89 $C2						#mov dx, ax
$8B $CF						#mov cx, di

#nextsprite:
$8B $7D $48					#mov di, [di+object.obj_next]
$0B $FF						#or di, di
$75 $E2						#jnz looptop

#now check if cx (obj pointer is set)
$83 $F9 $00					#cmp cx, 0
$74 $2D						#jz RETURN
$89 $CF						#mov di, cx

$8B $44 $44					#mov ax, [si+object.int34] ;found an active arachnut
$2B $06 $A54CW				#sub ax, [SpriteSync]
$3D $0W						#cmp ax, 0
$7E $15						#jle replace ; teleport if the timer drops below zero
$89 $44 $44					#mov [si+object.int34], ax
$8B $44 $0A					#mov ax, [si+object.xpos]
$3B $45 $0A					#cmp ax, [di+object.xpos]
$0F	$9E	$C0					#setle al
$98							#cbw
$48							#dec ax
$0C $01						#or al, 1
$89 $44 $0E #mov [si+object.int34], ax
$EB $0A						#jmp return ; decrease timer if smirky still sees the arachnut
$C7 $44 $1C $321EW			#REPLACE: mov [si+object.action], a_smirky teleport
$C7 $44 $44 210W			#mov [si+object.int34], TIMER
						 	#RETURN: 
$5F #pop di
$5E #pop si
$8B $E5 #mov bp, sp
$5D #pop bp
$CB #retf						



#NOVEL smirky post-stun teleport behaviour
#NOTE: This overwrites the original smirky search function; and is close to other new functions as well

%patch $11C04 
$55 #push bp
$8B $EC #mov bp, sp
$56 #push si
$57 #push di
$8B $76 $06 #mov si, [bp+arg0]

$8A	$44 $43					#mov al, [si+object.int33+1]
$C1 $E0 $08					#shl ax, 8
$89 $44 $0A					#mov [si+object.posx], ax
$8A	$44 $42					#mov al, [si+object.int33]
$C1 $E0 $08					#shl ax, 8
$05 $100W					#add ax, SOMEDIST ; enough to force it into the ground
$89 $44 $0C					#mov [si+object.posy], ax

$B8 $3368W #mov ax, a_smirky_stuntele0
$50 #push ax
$56 #push si
$9A $09DC05F9RL #call UpdateHitbox
$84 $C4 $04 #add sp, 4

$5F #pop di
$5E #pop si
$8B $E5 #mov bp, sp
$5D #pop bp
$CB #retf


#
#smirky teleport behaviour
#

%patch $11C62 10 #search for arachnuts

#
#smirky collision
#

#Change stealing candy to stunning arachnuts
%patch $11CA6 10  	# check if arachnut
	$75 $5D		# change jnz to end function if not an arachnut
				
						  # advance smirky action to teleport out sequence
%patch $11CA9 $C7 $44 $1C $330EW $90 $90 $90 $90  # don't change arachnut type or zplane
%patch $11CB3 $23B4W  #set contacted sprite action to stunned arachnut

#%patch $11CCB $90 $90 $90 $90 # remove return and stack frame restoration


	


#ACTIONS

# 2 frame walker
%patch $311E8 425W 427W $0W $0W $1W 6W $80W $0W $0L $0FA80B1CRL $09DC1795RL $2396W
%patch $31206 426W 428W $0W $0W $1W 6W $80W $0W $0FA80AF9RL $0FA80B1CRL $09DC1795RL $2378W

# falling down (4 frames)
%patch $31224
447W 447W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x23D2W
448W 448W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x23F0W
449W 449W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x240EW
450W 450W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x2594W

# 5 frame stunned loop
%patch $3129C
452W 452W 0W 0W 1W 20W 0W 0W 0L 0x0FA80CB0RL 0x09DC176ERL 0x244AW
453W 453W 0W 0W 1W 20W 0W 0W 0L 0x0FA80CB0RL 0x09DC176ERL 0x2468W
454W 454W 0W 0W 1W 20W 0W 0W 0L 0x0FA80CB0RL 0x09DC176ERL 0x2576W

%patch $313E6
455W 455W 0W 0W 1W 20W 0W 0W 0L 0x0FA80CB0RL 0x09DC176ERL 0x2594W
451W 451W 0W 0W 1W 140W 0W 0W 0x0FA80B48RL 0x0FA80CB0RL 0x09DC176ERL 0x242CW

# 8 frame get up sequence
%patch $31422
450W 450W 0W 0W 1W 20W 0W 0W 0L 0L 0x09DC176ERL 0x25D0W
451W 451W 0W 0W 1W 20W 0W 0W 0L 0L 0x09DC176ERL 0x25EEW
450W 450W 0W 0W 1W 20W 0W 0W 0L 0L 0x09DC176ERL 0x260CW
451W 451W 0W 0W 1W 20W 0W 0W 0L 0L 0x09DC176ERL 0x262AW
450W 450W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x2648W
449W 449W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x2666W
448W 448W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x2684W
447W 447W 0W 0W 1W 10W 0W 0W 0L 0L 0x09DC176ERL 0x2378W


# Squished frame
%patch $31512
456W 456W 0W 0W 1W 20W 0W 0W 0L 0L 0x09DC176ERL 0x26A2W


#using skypest preening actions 7+ for stuff
#will probably need to make a custom function with loop counter for arachnut stunned animation


#Don't stun arachnut when shot
#%patch $105B0 $90 $90 $90 $90 $90

# Kill the stunner bullet when it hits arachnut
%patch $105A8

$56 #push si
$9A $0D8F0D43RL #call StunnerZaps
$44 #inc sp
$44 #inc sp
$90 $90 $90 $90 $90 $90 $90 $90 #nopslide


#Change the Squished skypest action
%patch $10751 $26A2W
 

# Stunned loop timer
# This lets the 5  frame stun loop be run 3 times before the getup sequence runs
# It overwrites the original stunned arachnut collision code
%patch $105C8
$55		# push    bp
$8B $EC		# mov     bp, sp
$56		# push    si
$8B $76 $06	# mov     si, [bp+6]
$FF $44 $3E	# inc	  [si+OBJECT.int31]
$83 $7C $3E $03	# cmp	  [si+OBJECT.int31], 3W
$75 10 		# jnz	  return
$C7 $44 $3E $0W # mov	  [si+OBJECT.int31], 0
$C7 $44 $1C $25B2W # mov  [si+OBJECT.action], getupframe

# return:
$5E # pop     si
$5D # pop     bp
$CB # retf


# Actions
%patch $30F54 
0x145W 0x145W 3W 0W 0W 8W 0W 0W $0FA80493RL $0FA804BERL $0FA804ECRL 0x20E4W
0x146W 0x146W 3W 0W 0W 20W 0W 0W $09DC16C9RL $0FA804BERL $09DC176ERL 0x24E0W #up

# Borrowing skypest action space (first two preening actions)
%patch $31350
0x147W 0x147W 3W 0W 0W 30W 0W 0W $09DC16C9RL $0FA804BERL $09DC176ERL 0x24FEW #up
0x148W 0x148W 3W 0W 0W 20W 0W 0W $09DC16C9RL $0FA804BERL $09DC176ERL 0x20E4W #up




%patch $FF89
$8B $1E $A7D6W  # mov bx, [player]
$8B $47 $0A		# mov ax, [bx+object.xpos]
$2B	$44	$0A		# sub ax, [si+object.xpos]
$99				# cwd
$31 $D0			# xor ax, dx
$29 $D0			# sub ax, dx
$3D $0300W		# cmp ax, 0x300
$73 $20			# jge return
$C7 $44 $18 $FFb0W # mov [si+object.vely], -40
$C7 $44 $1C $2102W #mov [si+object.action], 2102
$EB $14			#

###
#Bounders
###


# Keen Collision Function
# Bounders are now toxic frog guys, so keen can't stand on them now

%patch $CCD2 $90 $90 $90 #nop slide over jump to call to keen-stand-on-bounder-funnctio

%patch $CDC9 $EB #and he can't stand on a stunned bounder ,either


# Actions
%patch $31D82
0x1EFW 0x1EFW 3W 0W 0W 20W 0W 0W	$09DC16C9RL $10800938RL $1080097ERL $2F30W  # sitting frame 1
0x1F0W 0x1F0W 3W 0W 0W 20W 0W 0W	$09DC16C9RL $10800938RL $1080097ERL $2F12W	# sitting frame 2
0x1ECW 0x1EEW 2W 0W 0W 20W 0W 0W	$09DC16C9RL $10800938RL $1080097ERL $2F4EW	# up frame
0x1EBW 0x1EDW 2W 0W 0W 20W 0W 0W	$09DC16C9RL $10800938RL $1080097ERL $2F6CW  # down frame
0x1EFW 0x1EFW 2W 0W 0W 0W 0W 0W 	$09DC16C9RL $0L			$09DC1913RL $2FA8W
0x1F1W 0x1F1W 2W 0W 0W 0W 0W 0W		$09DC16C9RL $0L			$09DC1913RL $0W


# NEW Bounder Draw Function
#1080097E
%patch $1117E
$55                  #push    bp                      
$8B $EC              #mov     bp, sp                  
$83 $EC $02          #sub     sp, 2                   
$56                  #push    si                      
$57                  #push    di                      
$8B $7E $06          #mov     di, [bp+arg_0]          

#botflags:
$83 $7D $3A $00      #cmp     [di+OBJECT.botflags], 0 
$74 $05              #jz      topflags
$C7 $45 $18 0W		 #mov     [di+OBJECT.ymove], 0    

					 #topflags:
					 #;increase int34 until threshold, then jump
$83 $7D $36 $00      #cmp     [di+OBJECT.topflags], 0 
$75 28		         #jnz      #onground
$81 $7D $1C $2F4EW   #cmp     [di+OBJECT.action], bounder_air
$74 18		         #jz      #sideflags

$B8 $2F4EW			 # mov ax, offset bounder_air
$50				     #push ax
$57					 #push di
$9A $09DC120ARL		 #call CheckGround2
$83 $C4 $04			 #add sp, 4
$C7 $45 $44 $0W		 #mov [di+objtype.int34], 0
$E9 99W		         #jmp sideflags

					 # onground:
$C7 $45 $16 $0000W   #mov [di+object.xmotion], 0000W
$81 $7D $1C $2F6CW   #cmp     [di+OBJECT.action], bounder_air
$74 13		         #jz      checkbouncetime
$B8 $2F6CW			 # mov ax, offset bounder_ground
$50				     # push ax
$57					 # push di
$9A $09DC120ARL		 # call CheckGround2
$83 $C4 $04			 # add sp, 4

					 # checkbouncetime:
$8B $45 $44			 #mov	ax, [di+objtype.int34]
$40					 #inc	ax
$89 $45 $44			 #mov	[di+objtype.int34], ax
$3D $0020W			 #cmp	ax, BOUNDERJUMPTIME
$7C 57				 #jl		sideflags

$C7 $45 $44 $0W		 #mov	word ptr [di+objtype.int34], 0
$8B $1E $A7D6W		 #mov bx, player
$8B $45 $0A			 #mov ax, [di+object.posx]
$39 $47 $0A			 #cmp [bx+object.posx], ax
$73 $07				 #jnb BounceRight
#BounceLeft:
$C7 $45 $0E $FFFFW   #mov [di+object.xmotion], FFFFW
$EB $05				 #jmp short dobounce
#BounceRight:
$C7 $45 $0E $0001W	 #mov [di+object.xmotion, 1W
#dobounce:
$8B $45 $0E			 # mov     ax, [di+OBJECT.xmotion]
$BA $10 $00 		 # mov     dx, 10h
$F7 $EA     		 # imul    dx
$89 $45 $16 		 # mov     [di+OBJECT.xmove], ax
$C7 $45 $18 $FFD0W	 #mov [di+OBJECT.ymove], FFD0

$B8 $0010W  $50 $9A $187409F1RL $83 $C4 $02 #Play sound

#11208
$83 $7D $38 $00     #sideflags:      cmp     [di+OBJECT.rightflags], 0
$75 $06             #                jnz     short reverseX
$83 $7D $3C $00     #                cmp     [di+OBJECT.leftflags], 0
$74 $10             #                jz      short draw
$8B $45 $0E         #reverseX:       mov     ax, [di+OBJECT.xmotion]
$F7 $D8             #                neg     ax
$89 $45 $0E         #                mov     [di+OBJECT.xmotion], ax
$8B $45 $16         #                mov     ax, [di+OBJECT.xmove]
$F7 $D8             #                neg     ax
$89 $45 $16         #                mov     [di+OBJECT.xmove], ax
$FF $75 $20         #draw:           push    [di+OBJECT.zplane] ; int
$33 $C0             #                xor     ax, ax
$50                 #                push    ax              ; int
$FF $75 $1E         #                push    [di+OBJECT.chunk] ; value
$FF $75 $0C         #                push    [di+OBJECT.ypos] ; int
$FF $75 $0A         #                push    [di+OBJECT.xpos] ; int
$8B $C7 $05			#                mov     ax, di
$46 $00             #                add     ax, 46h
$50                 #                push    ax              ; int
$9A $16541641RL	    #                call    RF_PlaceSprite                     
$83 $C4 $0C         #                add     sp, 0Ch                            
$5F                 #                pop     di                                 
$5E                 #                pop     si                                 
$8B $E5             #                mov     sp, bp                             
$5D                 #                pop     bp                                 
$CB                 #                retf                                       

#Collision
#Bounder kills Keen, can be shot: 
%patch $11138 
$55 
$8B $EC 
$56 $57 
$8B $76 $06 						# mov	si, [bp+6]
$8B $7E $08							# mov	di, [bp+8] 
$83 $3D $02							# cmp	[di], 2 ; stunner
$75 $09 
$9A $0B8013E9RL $5F $5E $5D $CB		# call killkeen and return 
$83 $3D $03							# cmp [di], 3  ; stunner
$75 $1D 
$C7 $44 $16 $00 $00 
$C7 $44 $06 $01 $00 
$B8 $A8 $2F 
$50 
$57 
$56 
$9A $09DC1695RL 
$83 $C4 $06 
#$C7 $44 $00 $00 $01	# type = 01,  (obj_friendly)
$90 $90 $90 $90 $90
$5F $5E $5D $CB






#3 frame loop
%patch $32700
$1B8W $1B8W $4W $0W $0W $10W $0W $0W $10800D44RL $11A20D86RL $09DC176ERL $38AEW 
$1B9W $1B9W $4W $0W $0W $10W $0W $0W $10800D44RL $11A20D86RL $09DC176ERL $38CCW 
$1BAW $1BAW $4W $0W $0W $10W $0W $0W $10800D44RL $11A20D86RL $09DC176ERL $3890W 

#Collision Function
#altered so that mine does not blow up and does not make sound when contact keen

%patch $127B9 $90 $90 $90 $90 $90 #don't change action to explosion
%patch $127C5 $90 $90 $90 $90 $90 #don't play a sound





#actions
#2 movement actions (smooth movement always thinking)
%patch $3154E
$1C9W $1C9W $1W $1W $1W $4W $11W $0W $10800071RL $108000B0RL $10800100RL $26FCW 
$1C9W $1C9W $1W $1W $1W $4W $11W $0W $10800071RL $108000B0RL $10800100RL $26DEW 
$1C9W $1C9W $1W $1W $1W $4W $18W $0W $0L         $108000B0RL $10800100RL $2738W 
$1C9W $1C9W $1W $1W $1W $4W $18W $0W $0L         $108000B0RL $10800100RL $26DEW 

#attacking actions
#stunned action

#default movement think
#if player is close enough, go to attacking action.

#spawn -- set health
%patch $1081C
$C7 $47 $3E 02W			#mov [si+objtype.int31], 2

%patch $10836
$40W				# map units to move sprite down on spawn

%patch $10871 
#$10800071RL
$55						#push bp
$8B $EC					#mov bp, sp
$56						#push si
$8B $76 $06 			#mov si, [bp+6]


						#checky;
$8B $1E $A7D6W			# mov bx, [player]
$8B $47 $32				#mov ax, [bx+boxT.lr.y]
$2B $44 $32				#sub ax, [si+boxT.lr.y]
$3D $2W					#cmp ax, 2
$7F  34					#jg return
$3D $FFFEW	  			#cmp ax, -2
$7C  29					#jl return
						
						#checkx:
$8B $47 $2A				# mov ax, [bx+object.boxXmid]
$2B $44	$2A				# sub ax, [si+object.boxXmid]
$3D $200W 				#cmp ax, 0x200
$7F  18					#jg return
$3D $FE00W				#cmp ax, 0xFE00
$7C  13	  				#jl return
						
						#doattack:
$B8 $271AW				#mov ax, a_wormmouthattack1
$50						#push ax
$56						#push si
$9A $09DC120ARL			#call CheckGround2
$83 $C4 $04				#add sp, 4

						#return:
$5E	
$8B $E5 
$5D			#pop si; mov sp, bp; pop bp
$CB						#retf
						


#collision
#check for shots, decrease health, set whiteflash, die if health <0
%patch $108B0
#$108000B0RL
$55						#push bp
$8B $EC					#mov bp, sp
$56						#push si
$57						#push di
$8B $76 $06 			#mov si, [bp+6]
$8B $7E $08 			#mov di, [bp+8]

						#kill keen
$83 $3D $02				#cmp word ptr [di], 2
$75  07					#jnz checkstunner
$9A $0B8013E9RL			#call KeenDie
$EB  44					#jmp return

						#checkstunner:
$83 $3D $03				#cmp word ptr [di], 3
$75	 39					#jnz return
$57						#push di
$9A $0D8F0D43RL			#call StunnerZaps
$83 $C4 $02				#add sp, 2
$FF $4C $3E				#dec [si+obtype.int31]
$75  20					#jnz notdead

						#dead:
$C7 $44 $40 0W			#mov [si+int32], 0
$B8 $2882W				#mov ax, a_wormmouthstunned
$50						#push ax
$56						#push si
$9A $09DC120ARL			#call CheckGround2
$83 $C4 $04				#add sp, 4
$EB  05					#jmp return

#notdead:
$C7 $44 $40 5W			#mov [si+int32], WHITEFLASH

#return:
$5F $5E $8B $E5 $5D $CB	#pop di;pop si; mov sp, bp; pop bp; retf



#drawfunc (decrease whiteflash, draw white if != 0) 
%patch $10900
#$10800100RL
$55						#push bp
$8B $EC					#mov bp, sp
$56						#push si      
$8B $76 $06 			#mov si, [bp+6]

#Portion of DrawFunc2 that turns actor around at walls and edges
$83 $7C $0E $01
$75 $2B 
$83 $7C $3C $00 
$74 $25  
$8B $44 $12 
$29 $44 $0A 
$C7 $44 $0E $FF $FF 
$9A $1D02002ARL      
$B1 $05 $D3 $F8 
$89 $44 $08 
$FF $74 $1C 
$56 
$9A $09DC120ARL		 
$83 $C4 $04 
$EB $5D 
$83 $7C $0E 
$FF $75 $2B 
$83 $7C $38 $00 
$74 $25 
$8B $44 $12 
$29 $44 $0A 
$C7 $44 $0E $01 $00 
$9A $1D02002ARL      
$B1 $05 $D3 $F8 
$89 $44 $08 
$FF $74 $1C $56 
$9A $09DC120ARL 
$83 $C4 $04 
$EB $2C 
$83 $7C $36 $00 
$75 $26 
$8B $44 $12 
$29 $44 $0A  
$8B $44 $0E 
$F7 $D8 
$89 $44 $0E 
$9A $1D02002ARL     
$B1 $05 $D3 $F8 
$89 $44 $08 
$FF $74 $1C 
$56 
$9A $09DC120ARL 
$83 $C4 $04

# Start Drawing
$FF $74 $20				#push [si+objtype.zplane]
$33 $C0					#xor ax, ax
$83 $7C $40 $00				#cmp [si+objtype.int32], 0
$74 $04					#jz draw
$FF $4C $40				#dec [si+obtype.int32]
$40						#inc ax ; push 1


#draw:
$50						#push ax
$FF $74 $1E
$FF $74 $0C 
$FF $74 $0A 
$8B $C6 
$05 $46 $00 
$50 
$9A $16541641RL 
$83 $C4 $0C 

$5E	$8B $E5 $5D			#pop si; mov sp, bp; pop bp
$CB						#retf	 
#Dopefish
#int31 is used by drawfunc
#int32 holds health
#int33 holds whiteflash timer
#int34 holds ?

#Actions
%patch $32430 #DS:35C0
#2 swimming actions: use dopefishmove , new collision, and rewritten draw functions
0x1A2W 0x194W 3W 0W 0W 20W 0W 0W $11A20711RL $11A20860RL $11A2077ARL $35DEW
0x1A3W 0x195W 3W 0W 0W 20W 0W 0W $11A20711RL $11A20860RL $11A2077ARL $35FCW

#1 short launching potentiator (deprotected)
0x1A3W 0x195W 0W 1W 0W 1W  0W 0W $11A207F0RL $11A20860RL $11A2077ARL $35C0W

# Launching schoolfish DS:361A
0x1A4W 0x196W 0W 1W 0W 1W  0W 0W $11A20920RL $11A20860RL $11A2077ARL $3638W
0x1A4W 0x196W 3W 0W 0W 60W 0W 0W $09DC171FRL $11A20860RL $11A2077ARL $35C0W


# Hit by stunner
#ds:3656
0x197W 0x197W 3W 0W 0W 60W 0W 0W $09DC171FRL $11A20860RL $11A2077ARL $3674W

# Dropping Egg
0x198W 0x198W 0W 1W 0W 1W  0W 0W $11A20830RL $11A20860RL $11A2077ARL $3692W
0x198W 0x198W 3W 0W 0W 60W 0W 0W $09DC171FRL $11A20860RL $11A2077ARL $35C0W



#SPAWN DOPEFISH

# change dopefish to normal enemy so that keen doesn't spawn wetsuit when ded
%patch $120C4 $15W #mimrock type
#
# set health at beginning
#
%patch $120EA
#$90 $90 $90 $90 $90		#nop out random X movement set
#$90 $90 $90
#$90 $90
#$8B $1E $D8 $A7			# set int32 to health = 10
#$C7 $47 $40 $10W
#$90 $90

# 21 bytes
$A1 $7A6CW				# mov ax, [difficulty]
$B9 8W					# mov cx, MULTIPLIER; = 8
$F7 $E1					# mul cx
$05 25W					# add ax, OFFSET ; = 16
$8B $1E $D8 $A7			# mov bx, [new_object]
$89 $47 $40 			# mov [bx+objtype.int32], ax ; set int32 to health
$90 $90 $90 


# dopefish left/right speed (default 10)
%patch $12157 20W

# dopefish movedown speed (default 10)
%patch $12173 2W




#The schoolfish draw function (shared with the dopefish) was modified.
#Rewriting the unmodified draw function over the DopefishEat function (which is no longer needed)
#TODO: Modified slightly for flash white
#Patched at $11A2077ARL
%patch $1219A
$55 $8B $EC $56			#push bp; mov bp,sp; push si
$8B $76 $06 
$83 $7C $3A $00 
$75 $06 
$83 $7C $36 $00 
$74 $09 
$83 $7C $3E $00 
$75 $03 
$FF $44 $3E 
$83 $7C $38 $00 
$75 $06 
$83 $7C $3C $00 
$74 $12 
$C7 $44 $16 $00 $00 
$8B $44 $0E 
$F7 $D8 
$89 $44 $0E 
$C7 $44 $3E $01 $00 
$83 $7C $3A $00 
$75 $0B 
$83 $7C $36 $00
$75 $05 
$C7 $44 $3E $00 $00 

# Start Drawing
$FF $74 $20				#push [si+objtype.zplane]
$33 $C0					#xor ax, ax
$83 $7C $42 $00				#cmp [si+objtype.int33], 0
$74 $04					#jz draw
$FF $4C $42				#dec [si+obtype.int33]
$40					#inc ax ; push 1

#draw:
$50					#push ax
$FF $74 $1E
$FF $74 $0C 
$FF $74 $0A 
$8B $C6 
$05 $46 $00 
$50 
$9A $16541641RL 
$83 $C4 $0C 

$5E $5D $CB			#pop si, bp, ret 

#start next patch at $12210

#
# Wrapper Movement function: Randomly spawns schoolfish missiles in direction of keen (switch to shooting action)
# If no missile spawn, then call normal DopefishMove function
# Set whiteflash to 0
#

#11A207F0
%patch $12210
$55 $8B $EC $56 $8B $76 $06		#push bp, mov bp, sp; push si; mov si, [bp+arg_0]
$9A $1D02002ARL					#call US_Rnd
$3D $00D0W						#cmp ax, 0xD0W
$7C $0D							#jl return
$B8 $361AW						#mov ax, offset A_LaunchSchoolfish
$50								#push ax
$56								#push si
$9A $09DC120ARL					#call CheckGround2
$83 $C4 $04						#add sp, 4
								#return:
$5E	$8B $E5 $5D					#pop si; mov sp, bp; pop bp
$CB							    #retf


#
# Post-damage function: Drop an egg 
#

#11A20830RL
%patch $12250
$55 $8B $EC $56 $8B $76 $06		#push bp, mov bp, sp; push si; mov si, [bp+arg_0]
$8B $44 $2E						#mov ax, [si+objtype.boxTY1]
$05 $0003W						#add ax, 3
$50								#push ax
$8B $44 $2C						#mov ax, [si+objtype.boxTX1]
$05 $0002W						#add ax, 2
$50								#push ax
$9A $0FA8055DRL					#Call spawn_egg
$83 $C4 $04						#add sp, 4
$B8 $0001W						#mov ax, xxxxW
$50								#push ax
$9A $187409F1RL					#call SD_PlaySound
$83 $C4 $02						#add sp, 2
#return:
$5E	$8B $E5 $5D					#pop si; mov sp, bp; pop bp
$CB							    #retf





#
# New Collision Function: if atroxus is shot from beneath or on top, set whiteflash to 1, set action to hit
#
#$11A20860RL
%patch $12280
$55 $8B $EC $56 $57 #push bp, mov bp, sp; push si; push di
$8B $76 $06						#mov si, [bp+arg_0]
$8B $7E $08						#mov di, [bp+arg_2]

								#kill keen
$83 $3D $02						#cmp word ptr [di], 2
$75 $07							#jnz checkstunner
$9A $0B8013E9RL					#call KeenDie
$EB $51							#jmp return

								#checkstunner:
$83 $3D $03						#cmp word ptr [di], 3
$75	$4C							#jnz return
$83 $7D $0E $00					#cmp word ptr [di+objtype.xmotion], 0
$75 $3D							#jnz stunnerzap
$8B $45 $26						#mov ax, [di+objtype.boxx2]  ; right of shot inside left of atroxus
$2B $44 $22						#sub ax, [si+objtype.boxx1]
$3D $200W						#cmp ax, 200 
$7C $3B							#jl return
$8B $45 $22						#mov ax, [di+objtype.boxx1]	 ; left of shot inside right of atroxus
$2B $44 $26						#cmp ax, [si+objtype.boxx2]
$3D $FE00W						#cmp ax, -200 
$7F $30							#jg return

#change the action to the painframe ONLY if we are not already in the painframe
#cycle

#check this by comparing the address of the action 
# Keen should be able to shoot the boss as many times as possible

$81 $7C $1C $3656W				#cmp word ptr [si+objtype.action], XXXXW
$73 13 							#jge reduce health

$B8 $3656W						#mov ax, a_painframe
$50								#push ax
$56								#push si
$9A $09DC120ARL					#call CheckGround2
$83 $C4 $04						#add sp, 4

#reducehealth:
$C7 $44 $42 5W					#mov [si+object.int33], FLASHTIME
$FF $4C $40						#dec [si+objtype.int32] ; health
$75 $09							#jnz stunnzerzap
$56								#push si
$9A $11A208E0RL					#call AtroxusDead
$83 $C4 $02						#add sp, 2

#stunnerzap:
$57								#push di
$9A $0D8F0D43RL					#call StunnerZaps
$83 $C4 $02						#add sp, 2



#return:
$5F $5E	$8B $E5 $5D				#pop di; pop si; mov sp, bp; pop bp
$CB							    #retf

#AtroxusDead: TODO: call this when atroxus dies (and set game exit type to win game)
#$11A208E0RL
%patch $12300
$55 $8B $EC $56 $57 #push bp, mov bp, sp; push si; push di
$8B $76 $06						#mov si, [bp+arg_0]
$8B $7E $08						#mov di, [bp+arg_2]

#Set the action to atroxus dead
#

$56					#push 	si 
$9A $06BD1E8BRL 			#call	RemoveObj
$44					#inc 	sp
$44					#inc	sp
$5F $5E	$8B $E5 $5D				#pop di; pop si; mov sp, bp; pop bp
$CB							    #retf


#ShootMissile:
#launch a schoolfish missile
#$11A20920RL
%patch $12340
$55 $8B $EC $56 $57				#push bp, mov bp, sp; push si; push di
$8B $76 $06						#mov si, [bp+arg_0]

$56								#push si
$9A $1080032ARL					#call cloud_strike
$83 $C4 $02						#add sp, 2

#set schoolfish velx higher (already patched int34 to hold the velocity)
$8B $1E $A7D8W					#mov bx, [new_object]
$C1 $67 $44 $01					#shl [bx+objtype.int34], 1

$5F $5E	$8B $E5 $5D				#pop di; pop si; mov sp, bp; pop bp
$CB							    #retf



### EGGS ###



#actions
%patch $30F90

#2 frame animation loop for falling
$16AW $16AW 3W 0W 0W 6W 0W 0W $09DC16C9RL $09DC1752RL $0FA80627RL $213EW
$16AW $16AW 3W 0W 0W 6W 0W 0W $09DC16C9RL $09DC1752RL $0FA80627RL $2120W

#2 frame decay sequence
$199W $199W 3W 0W 0W 12W 0W 0W $0FA8097FRL $09DC1752RL $09DC176ERL $217AW
$199W $199W 3W 0W 0W 12W 0W 0W $0FA8097FRL $09DC1752RL $09DC176ERL $215CW

#1 frame shell bit animation
$16AW $16AW 3W 0W 1W 12W 10W 10W $09DC16C9RL $09DC1752RL $0FA806E0RL $2198W


#Rewriting the "DrawEggshell function" to "explode the fireball"
#when the ground is hit

#seg10:

#0FA8:0627
%patch $100A7
$55					#push 	bp
$8B $EC 				#mov    bp, sp
$56					#push   si
$8B $76 $06				#mov    si, [bp+arg_0]
$83 $7C $36 $00				#cmp    [si+OBJECT.topflags], 0

$75 $3					#jnz     short ahead
$E9 123W 				#jmp	return

					#ahead:
#13
$B8 $215CW				#mov 	ax, a_decay0
$50					#push 	ax
$56					#push 	si
$9A $09DC120ARL				#call	CheckGround2
$83 $C4 $04				#add	sp, 4

#now spawn 2 fireball things going in either direction


#16
$B8 $01 $00			        #mov     ax, 1                      
$50                                     #push    ax                        
$9A $06BD1E11RL                         #call    GetNewObj                 
$83 $C4 $02                             #add     sp, 2                     
$8B $1E $D8 $A7                         #mov     bx, new_object            

#15
$C7 $07 $01 $00                         #mov     [bx+OBJECT.type], 1       
$C7 $47 $02 $03 $00                     #mov     [bx+OBJECT.active], 3     
$8B $44 $0A                             #mov     ax, [si+OBJECT.xpos]      
$89 $47 $0A                             #mov     [bx+OBJECT.xpos], ax      

#16
$8B $44 $0C                             #mov     ax, [si+OBJECT.ypos]      
$89 $47 $0C                             #mov     [bx+OBJECT.ypos], ax      
$C7 $47 $16 $E4 $FF                     #mov     [bx+OBJECT.xmove], 0FFE4h 
$B8 $98 $21                             #mov     ax, offset a_EggshellBitA0
$50                                     #push    ax                        
$53                                     #push    bx                        

#8
$9A $09DC118CRL                         #call    CheckGround               
$83 $C4 $04                             #add     sp, 4                     
					
#16
$B8 $01 $00			        #mov     ax, 1                      
$50                                     #push    ax                        
$9A $06BD1E11RL                         #call    GetNewObj                 
$83 $C4 $02                             #add     sp, 2                     
$8B $1E $D8 $A7                         #mov     bx, new_object            

#15
$C7 $07 $01 $00                         #mov     [bx+OBJECT.type], 1       
$C7 $47 $02 $03 $00                     #mov     [bx+OBJECT.active], 3     
$8B $44 $0A                             #mov     ax, [si+OBJECT.xpos]      
$89 $47 $0A                             #mov     [bx+OBJECT.xpos], ax      

#16
$8B $44 $0C                             #mov     ax, [si+OBJECT.ypos]      
$89 $47 $0C                             #mov     [bx+OBJECT.ypos], ax      
$C7 $47 $16 28W		                #mov     [bx+OBJECT.xmove], 0FFE4h 
$B8 $98 $21                             #mov     ax, offset a_EggshellBitA0
$50                                     #push    ax                        
$53                                     #push    bx                        

#8
$9A $09DC118CRL                         #call    CheckGround               
$83 $C4 $04                             #add     sp, 4                     
					#return:
$56					#push	si
$9A $09DC176ERL				#call	DrawFunc1
$44					#inc 	sp
$44					#inc 	sp
$5E					#pop	si
$5D					#pop	bp
$CB					#retf

#Tiledraw function that kills the fireball when it hits the bottom of the map
%patch $10160

$55					#push 	bp
$8B $EC 				#mov    bp, sp
$56					#push   si
$8B $76 $06				#mov    si, [bp+arg_0]
$83 $7C $36 $00				#cmp    [si+OBJECT.topflags], 0
$75 $0B					#jnz	ahead

$56					#push 	si 
$9A $06BD1E8BRL 			#call	RemoveObj
$44					#inc 	sp
$44					#inc	sp
$5E					#pop	si
$5D					#pop	bp
$CB					#retf

$56					#push	si
$9A $09DC176ERL				#call	DrawFunc1
$44					#inc 	sp
$44					#inc 	sp
$5E					#pop	si
$5D					#pop	bp
$CB					#retf


#Use the space from the egg tile collision function to make a function
#that times the fireball's life

#0FA8:097F
%patch $103FF
$55					#push 	bp
$8B $EC 				#mov    bp, sp
$56					#push   si
$8B $76 $06				#mov    si, [bp+arg_0]
$FF $44 $3E				#inc [si+objtype.int31]
$81 $7C $3E 210W			#cmp [si+objtype.int31], XXXXW
$7C $08					#jl return
$56					#push 	si 
$9A $06BD1E8BRL 			#call	RemoveObj
$44					#inc 	sp
$44					#inc	sp
					#return:
$5E					#pop	si
$5D					#pop	bp
$CB					#retf


#################
#Princess Lindsey
#################

#Lindsey just sits where she's placed
%patch $3275A 329W 329W 2W 0W 0W 20W 0W 0W $09DC171FRL 0L $09DC176ERL $38EAW

#Cache just one animation, chunk 329
#%patch $EE8F $3F31W #Lindsey (At $12821)
#%patch $12821 $FF $76 $FC $57 $9A $11A20DB5RL     $83 $C4 $04 $B8 $2A3ARW  $8A
#              $16 $EC $7A $8E $C0 $26 $08 $16 329W  $E9 $C5BFW

#Change music when Lindsey spoken to
#(ShowPrincessMessage)
%patch $EFDD $06BD20C7RL
%patch $EFD9 $0001W      #Play this level's song

#################
#3-up sprite	#
#################

#This patch MUST be used with LIndsey's still patch or Lindsey will be broken.
#Every level with a 3-UP needs a flask to be cached

#The 3-up sprite will use the 'I Keen' sprite square and has 3 frames of animation plus 1 got animation. It will give 3 lives and play the 1-UP sound when got. It uses Lindsey's cache and all of her animations.

#Disable EGAGRAPH check in Keen 4 (Frees 389 bytes at $3CF6)
%patch $3CE5 $90 $90

#I Keen tile spawns 3-up
#Because the wetsuit keen is never used, the "IKeen" infotile
#can go to Case 29, which is normally reserved for Swimming Keen spawn 
%patch $EECB $03FBW 

#3-up spawn code (Uses Lindsey cache at present
%patch $ECEF $9A $037D0526RL

#3-up spawn code = $037D0526RL
#This is patched over the routine that reference "EGA1.CK4" and is therefore unused space
%patch $3CF6 $55 $8B $EC $33 $C0 $50 $9A $06BD1E11RL     $83 $C4 $02 $8B $1E
             $D8 $A7 $C7 $07 $0001W  $C7 $47 $02 $0001W  $C7 $47 $20 $0003W
             $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B $46 $08 $05 $FFFDW
             $D3 $E0 $89 $47 $0C $B8 $3908W  $50 $53 $9A $09DC118CRL     $83
             $C4 $04 $5D $CB

#3-up sprite collision (With Keen gives 3 lives, play 1-Up sound $11) = $037D056ARL
%patch $3D3A $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $83 $3D $02 $75 $22
             $FF $06 $7A6AW  $FF $06 $7A6AW  $FF $06 $7A6AW  $C7 $44 $1C $04ACW #$011FW
                 $C7 $44 $10 $FFFFW  $B8 $0011W  $50 $9A $187409F1RL     $83
             $C4 $02 $5F $5E $5D $CB

#3-up actions, use 3 Lindsey actions: $3908W-$3944W; $0008W is anim speed
%patch $32778 $014AW $014AW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $037D056ARL   $09DC176ERL   $3926W
%patch $32796 $014BW $014BW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $037D056ARL   $09DC176ERL   $3944W
%patch $327B4 $014CW $014CW $0000W $0000W $0000W $0008W $0000W $0000W
              $00000000L    $037D056ARL   $09DC176ERL   $3908W

#3-up got action $011FW: acts like item got $0028W is appearance time, $0008W rise speed
# Lemm Edit: we'll stick this at DSEG:4AC , since 11F seems to be messing up the EnterKey Pause Menu
# This will make it overwrite the WallDebug text
%patch $2F31C 241W 241W $0001W $0000W $0000W $0028W $0000W $0008W
              $00000000L    $00000000L    $09DC176ERL   $0000W



#Need to increase Flask end chunk cache by 1
#because the wooden door now holds the 3-UP sprite shadow (which comes after the last flask)
#This means taht every level witha 3 up needs a flask

%patch $3072A $00F1W 
#Flask cache end

#################
# Foot			#
#################

# World map foot
# Location	X	Y
# Start		6D	04
# End		3C	0C

# boundary tile in x direction
%patch $DE38 $50W

#Foot location 1:
%patch $DE43 $6D #Horizontal location on map in tiles
%patch $DE58 $04 #Vertical location on map in tiles

#Location 2: (When exiting POTF)
%patch $DE78 $3C #Horizontal location on map in tiles
%patch $DE8C $0C #Vertical location on map in tiles

#Disable demos REMVOE THIS WHEN DEMOS WORK!
%patch $5901 $CB


#################
# Mooning		#
#################




%end
